local BagBox, BankBox

local Match, Med, Box
function ContainerFrame_UpdateSearchResults(frame)
	local id = frame:GetID();
	local name = frame:GetName().."Item";
	local itemButton, Box,kind,iD,Found
	local _, isFiltered;
	Match={}
	Med={}

	Box=strlower(BagItemSearchBox:GetText())
	for word in Box:gmatch("%S+") do table.insert(Match,strlower(word)) end
	for i=1, frame.size, 1 do
		Med={}
		stats=false
		itemButton = _G[name..i] or frame["Item"..i];
		iD = itemButton:GetID()
		GetContainerItemLink(id,iD)
		stats=BSP_Search(Match,GetContainerItemLink(id,iD))
		_, _, _, _, _, _, _, isFiltered = GetContainerItemInfo(id, iD);
		if ( isFiltered ) then
			if not(stats) then
				itemButton.searchOverlay:Show();
			else
			itemButton.searchOverlay:Hide();
			end
		else
			itemButton.searchOverlay:Hide();
		end
	end
end

function BSP_Search(Match,I_link)
	Med={}
	if I_link~="" and I_link then
		for k,v in pairs(GetItemStats(I_link)) do
			table.insert(Med,strlower(k))
		end
		local namn,_,_,Ilvl,_,_,kind,_,place=GetItemInfo(I_link)
		if kind then table.insert(Med,strlower(kind)) end
		if Ilvl then table.insert(Med,Ilvl) end
		if not(place=="") then table.insert(Med,strlower(place)) end
		Found=0
		for i=1, #Match do
			for q=1,#Med do
				if string.find(Med[q],Match[i]) then
					Found=Found+1
					break
				end
			end
		end
		if Found==#Match then
			return true
		else
			return false
		end
	else
		return false
	end
end
-----------------------------Add this search to other bag addons-----------------

local eventframe = CreateFrame("FRAME", "BspEventframe");

eventframe:RegisterEvent("ADDON_LOADED")




local function Inject()
	local E,L,V,P,G,B
	if IsAddOnLoaded("ElvUI") then
		E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
		B = E:GetModule('Bags');
		eventframe:UnregisterEvent("ADDON_LOADED")
		B.SetSearch = MyINVENTORY_SEARCH_UPDATE
	end
	if IsAddOnLoaded("ArkInventory") then
		ArkInventory.Frame_Item_Update_Fade=BSP_Arkupdate
	end
	if IsAddOnLoaded("Bagnon") then
		BSP_Bagnon()
	end
end

local function eventHandler(self,event,...)
	if event=="ADDON_LOADED" and ...=="Bagsearchplus" then
		Inject()
	elseif event=="ADDON_LOADED" and ...=="ElvUI" then
		Inject()
	elseif event=="ADDON_LOADED" and ...=="ArkInventory" then
		Inject()
	elseif event=="ADDON_LOADED" and ...=="Bagnon" then
		Inject()
	end
end

eventframe:SetScript("OnEvent", eventHandler);


----------------------------------Elv UI---------------------------

function MyINVENTORY_SEARCH_UPDATE()
	Match={}
	local BagBox=strlower(ElvUI_ContainerFrameEditBox:GetText())
	if ElvUI_BankContainerFrameEditBox then
		BankBox=strlower(ElvUI_BankContainerFrameEditBox:GetText())
	end
	if not(BagBox=="search") then
		Box=BagBox
	elseif not(BankBox=="search") then
		Box=BankBox
	else
		Box=""
	end
	--Box=strlower(ElvUI_ContainerFrameEditBox:GetText()) or strlower(ElvUI_BankContainerFrameEditBox:GetText())
	--if Box~="search" then
	--	SetItemSearch(Box)
	--else
	if Box then
		SetItemSearch(Box)
	else
		SetItemSearch("")
	end
	if Box then
		for word in Box:gmatch("%S+") do table.insert(Match,strlower(word)) end
	end
	for _, bagFrame in pairs(B.BagFrames) do

		for _, bagID in ipairs(bagFrame.BagIDs) do
			for slotID = 1, GetContainerNumSlots(bagID) do
				Med={}
				stats=false
				GetContainerItemLink(bagID, slotID)
				local _, _, _, _, _, _, _, isFiltered = GetContainerItemInfo(bagID, slotID);
				local button = bagFrame.Bags[bagID][slotID];

				local stats=BSP_Search(Match,GetContainerItemLink(bagID, slotID))
				if ( isFiltered ) then
					if stats==true then
						SetItemButtonDesaturated(button);
						button:SetAlpha(1)
					else
						SetItemButtonDesaturated(button, 1);
						button:SetAlpha(0.4);
					end
				else
					SetItemButtonDesaturated(button);
					button:SetAlpha(1);
				end
			end
		end
	end

	if(ElvUIReagentBankFrameItem1) then
		for slotID=1, 98 do
			Med={}
			stats=false
			local _, _, _, _, _, _, _, isFiltered = GetContainerItemInfo(REAGENTBANK_CONTAINER, slotID);
			local button = _G["ElvUIReagentBankFrameItem"..slotID]
			if word then
				local stats=BSP_Search(word,GetContainerItemLink(REAGENTBANK_CONTAINER,slotID))
			end
			if ( isFiltered ) then
				if stats==true then
					SetItemButtonDesaturated(button);
					button:SetAlpha(1)
				else
					SetItemButtonDesaturated(button, 1);
					button:SetAlpha(0.4);
				end
			else
				SetItemButtonDesaturated(button);
				button:SetAlpha(1);
			end
		end
	end
end

----------------------------For ArkInventory---------------------

function BSP_Arkupdate( frame )
local special=false
local Match={}
	if not ArkInventory.ValidFrame( frame, true ) then return end
	local loc_id = frame.ARK_Data.loc_id
	local alpha = 1
	if ArkInventory.Global.Location[loc_id].isOffline and ArkInventory.LocationOptionGet( loc_id, "slot", "offline", "fade" ) then
		alpha = 0.6
	else
		if loc_id == ArkInventory.Const.Location.Vault then
			local bag_id = frame.ARK_Data.bag_id
			local canDeposit, numWithdrawals = select( 4, GetGuildBankTabInfo( bag_id ) )
			if not canDeposit and numWithdrawals == 0 then
				alpha = 0.6
			end
		end
	end
	local f = string.lower( string.trim( ArkInventory.Global.Location[loc_id].filter or "" ) )
	if f ~= "" then
		local Match={}
		for word in f:gmatch("%S+") do table.insert(Match,strlower(word)) end
		local i = ArkInventory.Frame_Item_GetDB( frame ) or { }
		local n = string.lower( select( 3, ArkInventory.ObjectInfo( i.h ) ) or "" )
		local I_link = select( 2, ArkInventory.ObjectInfo( i.h ) ) or ""
		if not string.find( n, string.trim( f ) ) then
			-- drop alpha to 0.2 for all non matching items
			if BSP_Search(Match,I_link)==false then
				alpha = 0.2
			end
		end
	end
	frame:SetAlpha( alpha )
end

--------------------------------------For Bagnon------------------------
function BSP_Bagnon()
	function Bagnon.ItemSlot:UpdateSearch()
		local search = self:GetItemSearch()
		local Match={}
			for word in search:gmatch("%S+") do table.insert(Match,strlower(word)) end
		local matches = search == '' or BSP_Search(Match,self.hasItem)
		if matches then
			self:SetAlpha(1)
			self:UpdateLocked()
			self:UpdateSlotColor()
			self:UpdateBorder()
		else
			SetItemButtonDesaturated(self, true)
			self:SetAlpha(0.4)
			self:HideBorder()
		end
	end
end


